
// Example: locality of memory references
// Use gcc -std=c99
// Run program with/without argument, e.g.:
//  1)  time ./prog arg
//  2)  time ./prog

#include <stdio.h>

#define N 10000
int p[N][N];

int main(int argc, char *argv[])
{
    printf("%dx%d int array using ", N, N);
    if (argc > 1) {
        puts("column-major access");
        for (int j = 0; j < N; ++j)
            for (int i = 0; i < N; ++i)
                p[i][j] = i + j;
    } else {
        puts("row-major access");
        for (int i = 0; i < N; ++i)
            for (int j = 0; j < N; ++j)
                p[i][j] = i + j;
    }
    return p[10][10];
}

